/****************************************************************************/
/* gettoken -- get a token                                                  */
/*--------------------------------------------------------------------------*/
/* copyright 1984, 88, 91, 92  Michael M Rubenstein                         */
/****************************************************************************/

#include <stdio.h>
#include <ctype.h>
#include "m4.h"

/****************************************************************************/
/* get a token                                                              */
/****************************************************************************/
int gettoken(char *token, int toksize)
{
  int                   c;
  int                   n;
  char                  *p;

  *(token++) = (char) (c = ngetc());
  *token = '\0';
  switch (c)
  {
    case 0:
    case EOF:           return c;

    default:            if (c == lparen)
                          return LPAREN;
                        if (c == rparen)
                          return RPAREN;
                        if (c == comma)
                          return COMMA;
                        if (c == comment)
                          return COMMENT;
                        if (c == lquote)
                          return LQUOTE;
                        n = toksize;
                        for (p = aquotes; *p; p += 2)
                          if (c == (*p & 0xff))
                          {
                            ++p;
                            while (--n)
                              if ((c = ngetc()) == EOF
                               || (*(token++) = (char) c) == (*p & 0xff))
                              {
                                *token = EOS;
                                return 0;
                              }
                            error("token too long.");
                          }

                        if (macchr != '\0')
                        {
                          if (c != macchr)
                            return 0;
                          putbak(c = ngetc());
                        }

                        if (!(isalpha(c) || c == '_'))
                          return 0;

                        do
                        {
                          if (n-- <= 0)
                            error("token too long.");
                          *(token++) = (char) (c = ngetc());
                        }  while (isalpha(c) || isdigit(c) || c == '_');
                        putbak(c);
                        if (c == EOF)
                          --token;
                        *(token - 1) = EOS;
                        return WORD;
  }
}
